#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int n,m;
    cin>>n>>m;
    long long a[1515][1515];
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>a[i][j];
        }
    }
    bool b[33][3030];
    for(int i=0;i<=30;i++){
        for(int j=0;j<n+m-1;j++){
            b[i][j]=false;
        }
    }
    long long x=1;
    for(int k=0;k<=30;k++){
        for(int i=0;i<n;i++){
            for(int j=0;j<m;j++){
                if(a[i][j]&(1<<k)){
                    b[k][i+j]=!b[k][i+j];
                }
            }
        }
    }
    int f[33];
    for(int i=0;i<=30;i++){
        f[i]=0;
        for(int j=0;j<n+m-1;j++){
            if(b[i][j]){
                f[i]++;
            }
        }
        f[i]=min(f[i],n+m-1-f[i]);
    }
    long long ans=0;
    x=1;
    for(int i=0;i<=30;i++){
        ans=ans+x*f[i];
        x=x*2;
    }
    cout<<ans;
    return 0;
}